## goxel 0.7.1

=== SConstruct ===
import glob
import os
import sys

# CCFLAGS   : C and C++
# CFLAGS    : only C
# CXXFLAGS  : only C++

target_os = str(Platform())

debug = int(ARGUMENTS.get('debug', 1))
profile = int(ARGUMENTS.get('profile', 0))
glut = int(ARGUMENTS.get('glut', 0))
emscripten = ARGUMENTS.get('emscripten', 0)
werror = int(ARGUMENTS.get("werror", 1))
clang = int(ARGUMENTS.get("clang", 0))
sound = False

if profile: debug = 0
if emscripten: target_os = 'js'

env = Environment(ENV = os.environ)
conf = env.Configure()

if clang:
    env.Replace(CC='clang', CXX='clang++')

# Asan & Ubsan (need to come first).
if debug and target_os == 'posix':
    env.Append(CCFLAGS=['-fsanitize=address', '-fsanitize=undefined'],
               LIBS=['asan', 'ubsan'])

env.Append(CFLAGS= '-Wall -std=gnu99 -Wno-unknown-pragmas',
           CXXFLAGS='-std=gnu++11 -Wall -Wno-narrowing '
                    '-Wno-unknown-pragmas -Wno-unused-function'
        )

if werror:
    env.Append(CCFLAGS='-Werror')

if debug:
    if env['CC'] == 'gcc':
        env.Append(CFLAGS='-Og')
else:
    env.Append(CCFLAGS='-Ofast -DNDEBUG')

if profile or debug:
    env.Append(CCFLAGS='-g')

env.Append(CPPPATH=['src'])

sources = glob.glob('src/*.c') + glob.glob('src/*.cpp') + \
          glob.glob('src/formats/*.c') + \
          glob.glob('src/tools/*.c')

if target_os == 'posix':
    env.Append(LIBS=['GL', 'm', 'z'])
    # Note: add '--static' to link with all the libs needed by glfw3.
    env.ParseConfig('pkg-config --libs glfw3')

if glut:
    env.Append(CCFLAGS='-DUSE_GLUT=1', LIBS='glut')

if target_os == 'msys':
    env.Append(CCFLAGS='-DNO_ARGP')
    env.Append(LIBS=['glfw3', 'opengl32', 'Imm32', 'gdi32', 'Comdlg32',
                     'z', 'tre', 'intl', 'iconv'],
               LINKFLAGS='--static')

if target_os == 'darwin':
    sources += glob.glob('src/*.m')
    env.Append(FRAMEWORKS=['OpenGL', 'Cocoa'])
    env.Append(LIBS=['m', 'z', 'argp', 'glfw3', 'objc'])

env.Append(CPPPATH=['ext_src/uthash'])
env.Append(CPPPATH=['ext_src/stb'])
env.Append(CPPPATH=['ext_src/noc'])

if conf.CheckLib('libpng'):
    env.Append(CCFLAGS='-DHAVE_LIBPNG=1')

sources += glob.glob('ext_src/imgui/*.cpp')
env.Append(CPPPATH=['ext_src/imgui'])
env.Append(CXXFLAGS='-DIMGUI_INCLUDE_IMGUI_USER_INL')

sources += glob.glob('ext_src/inih/*.c')
env.Append(CPPPATH=['ext_src/inih'])
env.Append(CFLAGS='-DINI_HANDLER_LINENO=1')

if target_os == 'posix':
    env.ParseConfig('pkg-config --cflags --libs gtk+-3.0')

if target_os == 'msys':
    sources += glob.glob('ext_src/glew/glew.c')
    env.Append(CPPPATH=['ext_src/glew'])
    env.Append(CCFLAGS='-DGLEW_STATIC')

if target_os == 'js':
    assert(os.environ['EMSCRIPTEN_TOOL_PATH'])
    env.Tool('emscripten', toolpath=[os.environ['EMSCRIPTEN_TOOL_PATH']])

    funcs = ['_main']
    funcs = ','.join("'{}'".format(x) for x in funcs)
    flags = [
             '-s', 'ALLOW_MEMORY_GROWTH=1',
             '-s', 'USE_GLFW=3',
             '-Os',
             '-s', 'NO_EXIT_RUNTIME=1',
             '-s', '"EXPORTED_FUNCTIONS=[{}]"'.format(funcs),
            ]

    env.Append(CCFLAGS=['-DGLES2 1', '-DNO_ZLIB', '-DNO_ARGP'] + flags)
    env.Append(LINKFLAGS=flags)
    env.Append(LIBS=['GL'])

if sound:
    env.Append(LIBS='openal')
    env.Append(CCFLAGS='-DSOUND=OPENAL')

env.Program(target='goxel', source=sources)

=== debian/changelog ===
goxel (0.7.1-2) unstable; urgency=medium

  * Initial release (Closes: #876204)

 -- Federico Ceratto <federico@debian.org>  Tue, 03 Oct 2017 13:47:45 +0100

=== debian/control ===
Source: goxel
Section: graphics
Priority: optional
Maintainer: Federico Ceratto <federico@debian.org>
Build-Depends: debhelper (>= 10~),
 help2man,
 libglfw3-dev,
 libgtk-3-dev,
 scons,
 uthash-dev
Standards-Version: 4.0.0
Homepage: https://github.com/guillaumechereau/goxel
Vcs-Git: https://anonscm.debian.org/collab-maint/goxel.git
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/goxel.git

Package: goxel
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: 3D voxel editor
 Goxel is a 3D program that lets you create voxel volumes.
 It supports 24 bits RGB colors, unlimited scene size and undo buffers.
 Layers, procedural generation and Marching Cube rendering.
 Exports to obj, pyl, magica voxel, png, qubicle, povray, and more
 .
 goxel is a popular editor and there are no similar applications in
 Debian. The package will be maintained on collab-maint.

## goxel 0.7.2

=== Makefile ===

all:
	scons -j 8

release:
	scons debug=0

profile:
	scons profile=1

run:
	./goxel

.PHONY: js
js:
	$(EMSCRIPTEN)/emscons scons debug=0 emscripten=1

clean:
	scons -c

=== SConstruct ===
--- 
+++ 
@@ -14,6 +14,7 @@
 emscripten = ARGUMENTS.get('emscripten', 0)
 werror = int(ARGUMENTS.get("werror", 1))
 clang = int(ARGUMENTS.get("clang", 0))
+argp_standalone = int(ARGUMENTS.get("argp_standalone", 0))
 sound = False
 
 if profile: debug = 0
@@ -28,9 +29,12 @@
 # Asan & Ubsan (need to come first).
 if debug and target_os == 'posix':
     env.Append(CCFLAGS=['-fsanitize=address', '-fsanitize=undefined'],
-               LIBS=['asan', 'ubsan'])
+               LINKFLAGS=['-fsanitize=address', '-fsanitize=undefined'])
+    if not clang:
+        env.Append(LIBS=['asan', 'ubsan'])
 
-env.Append(CFLAGS= '-Wall -std=gnu99 -Wno-unknown-pragmas',
+env.Append(CFLAGS= '-Wall -std=gnu99 -Wno-unknown-pragmas '
+                   '-Wno-unknown-warning-option',
            CXXFLAGS='-std=gnu++11 -Wall -Wno-narrowing '
                     '-Wno-unknown-pragmas -Wno-unused-function'
         )
@@ -55,11 +59,16 @@
 
 if target_os == 'posix':
     env.Append(LIBS=['GL', 'm', 'z'])
+    if not conf.CheckDeclaration('__GLIBC__', includes='#include <features.h>'):
+        env.Append(LIBS=['argp'])
     # Note: add '--static' to link with all the libs needed by glfw3.
     env.ParseConfig('pkg-config --libs glfw3')
 
 if glut:
     env.Append(CCFLAGS='-DUSE_GLUT=1', LIBS='glut')
+
+if argp_standalone:
+    env.Append(LIBS='argp')
 
 if target_os == 'msys':
     env.Append(CCFLAGS='-DNO_ARGP')
@@ -117,4 +126,11 @@
     env.Append(LIBS='openal')
     env.Append(CCFLAGS='-DSOUND=OPENAL')
 
+# Append external environment flags
+env.Append(
+    CFLAGS=os.environ.get("CFLAGS", "").split(),
+    CXXFLAGS=os.environ.get("CXXFLAGS", "").split(),
+    LINKFLAGS=os.environ.get("LDFLAGS", "").split()
+)
+
 env.Program(target='goxel', source=sources)

=== debian/changelog ===
goxel (0.7.2-1) unstable; urgency=medium

  * New upstream release
  * Add supported architectures (Closes: #882530)
  * Update description (Closes: #882516)

 -- Federico Ceratto <federico@debian.org>  Fri, 24 Nov 2017 23:54:57 +0000

=== debian/control ===
Source: goxel
Section: graphics
Priority: optional
Maintainer: Federico Ceratto <federico@debian.org>
Build-Depends: debhelper (>= 10~),
 help2man,
 libglfw3-dev,
 libgtk-3-dev,
 scons,
 uthash-dev
Standards-Version: 4.1.1
Homepage: https://github.com/guillaumechereau/goxel
Vcs-Git: https://anonscm.debian.org/collab-maint/goxel.git
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/goxel.git

Package: goxel
Architecture: amd64 arm64 armel armhf i386 m68k mips mips64el mipsel powerpc ppc64 ppc64el s390x sh4 x32
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: 3D voxel editor
 Goxel is a 3D program that lets you create voxel volumes.
 It supports 24 bits RGB colors, unlimited scene size and undo buffers.
 Layers, procedural generation and Marching Cube rendering.
 Exports to obj, pyl, magica voxel, png, qubicle, povray, and more

=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE = 1
VERSION ?= $(shell dpkg-parsechangelog --show-field Version)

%:
	dh $@

override_dh_auto_clean:
	scons -c
	rm -rf .sconf_temp config.log debian/goxel.1 goxel.xpm goxel.png

override_dh_auto_build:
	mv ext_src .ext_src
	mkdir ext_src
	cp -a .ext_src/imgui ext_src
	cp -a .ext_src/inih ext_src
	cp -a .ext_src/noc ext_src
	cp -a .ext_src/stb ext_src
	rm -rf .ext_src
	scons debug=0 -j 8 --no-cache
	cp -a ./osx/goxel/goxel/Assets.xcassets/AppIcon.appiconset/64.png ./goxel.png

override_dh_installman:
	help2man -N --no-discard-stderr \
		--no-info --version-string="${VERSION}" \
		-n "3D voxel editor" ./goxel > debian/goxel.1
	dh_installman ./debian/goxel.1

## goxel 0.7.3

=== Makefile ===
--- 
+++ 
@@ -17,3 +17,16 @@
 
 clean:
 	scons -c
+
+# Make the doc using natualdocs.  On debian, we only have an old version
+# of naturaldocs available, where it is not possible to exclude files by
+# pattern.  I don't want to parse the C files (only the headers), so for
+# the moment I use a tmp file to copy the sources and remove the C files.
+# It's a bit ugly.
+.PHONY: doc
+doc:
+	rm -rf /tmp/goxel_src
+	cp -rf src /tmp/goxel_src
+	find /tmp/goxel_src -name '*.c' | xargs rm
+	mkdir -p doc ndconfig
+	naturaldocs -i /tmp/goxel_src -o html doc -p ndconfig

=== SConstruct ===
--- 
+++ 
@@ -17,6 +17,7 @@
 argp_standalone = int(ARGUMENTS.get("argp_standalone", 0))
 sound = False
 
+if os.environ.get('CC') == 'clang': clang = 1
 if profile: debug = 0
 if emscripten: target_os = 'js'

## goxel 0.8.0

=== Makefile ===
--- 
+++ 
@@ -1,3 +1,5 @@
+SHELL = bash
+.ONESHELL:
 
 all:
 	scons -j 8
@@ -30,3 +32,32 @@
 	find /tmp/goxel_src -name '*.c' | xargs rm
 	mkdir -p doc ndconfig
 	naturaldocs -i /tmp/goxel_src -o html doc -p ndconfig
+
+# Targets to install/uninstall goxel and its data files on unix system.
+PREFIX ?= /usr/local
+
+.PHONY: install
+install:
+	install -Dm744 goxel $(DESTDIR)$(PREFIX)/bin/goxel
+	for size in 16 24 32 48 64 128 256; do
+	    install -Dm644 data/icons/icon$${size}.png \
+	        $$(printf '%s%s' $(DESTDIR)$(PREFIX)/share/icons/hicolor/ \
+	            $${size}x$${size}/apps/goxel.png)
+	done
+	install -Dm644 snap/gui/goxel.desktop \
+	    $(DESTDIR)$(PREFIX)/share/applications/goxel.desktop
+	install -Dm644 \
+	    snap/gui/io.github.guillaumechereau.Goxel.appdata.xml \
+	    $$(printf '%s%s' $(DESTDIR)$(PREFIX)/share/metainfo/ \
+	        io.github.guillaumechereau.Goxel.appdata.xml)
+
+.PHONY: uninstall
+uninstall:
+	rm -f $(DESTDIR)$(PREFIX)/bin/goxel
+	for size in 16 24 32 48 64 128 256; do \
+	    rm -f $$(printf '%s%s' $(DESTDIR)$(PREFIX)/share/icons/hicolor/ \
+	        $${size}x$${size}/apps/goxel.png)
+	done
+	rm -f $(DESTDIR)$(PREFIX)/share/applications/goxel.desktop
+	rm -f $$(printf '%s%s' $(DESTDIR)$(PREFIX)/share/metainfo/ \
+	         io.github.guillaumechereau.Goxel.appdata.xml)

=== SConstruct ===
--- 
+++ 
@@ -15,6 +15,7 @@
 werror = int(ARGUMENTS.get("werror", 1))
 clang = int(ARGUMENTS.get("clang", 0))
 argp_standalone = int(ARGUMENTS.get("argp_standalone", 0))
+cycles = int(ARGUMENTS.get('cycles', 1))
 sound = False
 
 if os.environ.get('CC') == 'clang': clang = 1
@@ -28,11 +29,17 @@
     env.Replace(CC='clang', CXX='clang++')
 
 # Asan & Ubsan (need to come first).
+# Cycles doesn't like libasan with clang, so we only use it on
+# C code with clang.
 if debug and target_os == 'posix':
-    env.Append(CCFLAGS=['-fsanitize=address', '-fsanitize=undefined'],
-               LINKFLAGS=['-fsanitize=address', '-fsanitize=undefined'])
     if not clang:
-        env.Append(LIBS=['asan', 'ubsan'])
+        env.Append(CCFLAGS=['-fsanitize=address', '-fsanitize=undefined'],
+                   LINKFLAGS=['-fsanitize=address', '-fsanitize=undefined'],
+                   LIBS=['asan', 'ubsan'])
+    else:
+        env.Append(CFLAGS=['-fsanitize=address', '-fsanitize=undefined'],
+                   LINKFLAGS=['-fsanitize=address', '-fsanitize=undefined'])
+
 
 env.Append(CFLAGS= '-Wall -std=gnu99 -Wno-unknown-pragmas '
                    '-Wno-unknown-warning-option',
@@ -45,9 +52,9 @@
 
 if debug:
     if env['CC'] == 'gcc':
-        env.Append(CFLAGS='-Og')
+        env.Append(CFLAGS='-Og', CXXFLAGS='-O1')
 else:
-    env.Append(CCFLAGS='-Ofast -DNDEBUG')
+    env.Append(CCFLAGS='-DNDEBUG', CFLAGS='-Ofast', CXXFLAGS='-Ofast')
 
 if profile or debug:
     env.Append(CCFLAGS='-g')
@@ -73,6 +80,8 @@
 
 if target_os == 'msys':
     env.Append(CCFLAGS='-DNO_ARGP')
+    env.Append(CXXFLAGS=['-Wno-attributes', '-Wno-unused-variable',
+                         '-DFREE_WINDOWS'])
     env.Append(LIBS=['glfw3', 'opengl32', 'Imm32', 'gdi32', 'Comdlg32',
                      'z', 'tre', 'intl', 'iconv'],
                LINKFLAGS='--static')
@@ -91,11 +100,54 @@
 
 sources += glob.glob('ext_src/imgui/*.cpp')
 env.Append(CPPPATH=['ext_src/imgui'])
-env.Append(CXXFLAGS='-DIMGUI_INCLUDE_IMGUI_USER_INL')
+env.Append(CXXFLAGS=['-DIMGUI_INCLUDE_IMGUI_USER_INL',
+                     '-DIMGUI_DISABLE_OBSOLETE_FUNCTIONS'])
 
 sources += glob.glob('ext_src/inih/*.c')
 env.Append(CPPPATH=['ext_src/inih'])
 env.Append(CFLAGS='-DINI_HANDLER_LINENO=1')
+
+# Cycles rendering support.
+if cycles:
+    sources += glob.glob('ext_src/cycles/src/util/*.cpp')
+    sources = [x for x in sources if not x.endswith('util_view.cpp')]
+    sources += glob.glob('ext_src/cycles/src/bvh/*.cpp')
+    sources += glob.glob('ext_src/cycles/src/render/*.cpp')
+    sources += glob.glob('ext_src/cycles/src/graph/*.cpp')
+    sources = [x for x in sources if not x.endswith('node_xml.cpp')]
+
+    sources += glob.glob('ext_src/cycles/src/device/device.cpp')
+    sources += glob.glob('ext_src/cycles/src/device/device_cpu.cpp')
+    sources += glob.glob('ext_src/cycles/src/device/device_memory.cpp')
+    sources += glob.glob('ext_src/cycles/src/device/device_denoising.cpp')
+    sources += glob.glob('ext_src/cycles/src/device/device_split_kernel.cpp')
+    sources += glob.glob('ext_src/cycles/src/device/device_task.cpp')
+
+    sources += glob.glob('ext_src/cycles/src/kernel/kernels/cpu/*.cpp')
+    sources += glob.glob('ext_src/cycles/src/subd/*.cpp')
+
+    env.Append(CPPPATH=['ext_src/cycles/src'])
+    env.Append(CPPPATH=['ext_src/cycles/third_party/atomic'])
+    env.Append(CPPFLAGS=[
+        '-DCYCLES_STD_UNORDERED_MAP',
+        '-DCCL_NAMESPACE_BEGIN=namespace ccl {',
+        '-DCCL_NAMESPACE_END=}',
+        '-DWITH_CUDA_DYNLOAD',
+        '-DWITHOUT_OPENIMAGEIO',
+        '-DWITH_GLEW_MX',
+        '-DWITH_CYCLES',
+    ])
+    # Try to improve compilation speed on linux.
+    if not clang: env.Append(CPPFLAGS='-fno-var-tracking-assignments')
+    # This seems to fix a crash on windows.
+    if target_os == 'msys':
+        env.Append(CXXFLAGS='-msse2 -O3 -fno-tree-slp-vectorize')
+
+env.Append(CPPFLAGS=['-Wno-sign-compare', '-Wno-strict-aliasing',
+                     '-Wno-uninitialized'])
+if clang:
+    env.Append(CPPFLAGS=['-Wno-overloaded-virtual'])
+
 
 if target_os == 'posix':
     env.ParseConfig('pkg-config --cflags --libs gtk+-3.0')

=== debian/changelog ===
goxel (0.8.0-1) unstable; urgency=medium

  * New upstream release (Closes: #906469, #891888)

 -- Federico Ceratto <federico@debian.org>  Sat, 18 Aug 2018 11:52:36 +0100

goxel (0.7.3-1) unstable; urgency=medium

  * New upstream release

 -- Federico Ceratto <federico@debian.org>  Sun, 18 Mar 2018 19:44:50 +0000

=== debian/control ===
Source: goxel
Section: graphics
Priority: optional
Maintainer: Federico Ceratto <federico@debian.org>
Build-Depends: debhelper (>= 11~),
 help2man,
 libglfw3-dev,
 libgtk-3-dev,
 libinih-dev,
 scons,
 uthash-dev
Standards-Version: 4.2.0
Homepage: https://github.com/guillaumechereau/goxel
Vcs-Git: https://salsa.debian.org/debian/goxel.git
Vcs-Browser: https://salsa.debian.org/debian/goxel

Package: goxel
Architecture: amd64 arm64 armel armhf i386 m68k mips mips64el mipsel powerpc ppc64 ppc64el s390x sh4 x32
Depends: ${shlibs:Depends}, ${misc:Depends}, libinih1
Description: 3D voxel editor
 Goxel is a 3D program that lets you create voxel volumes.
 It supports 24 bits RGB colors, unlimited scene size and undo buffers.
 Layers, procedural generation and Marching Cube rendering.
 Exports to obj, pyl, magica voxel, png, qubicle, povray, and more

=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE = 1

include /usr/share/dpkg/default.mk  # provides DEB_VERSION

%:
	dh $@

override_dh_auto_clean:
	scons -c
	rm -rf .sconf_temp config.log debian/goxel.1 goxel.xpm goxel.png
	if [ -d .ext_src ]; then rm ext_src -rf; mv .ext_src ext_src; fi

override_dh_auto_build:
	mv ext_src .ext_src
	mkdir ext_src
	cp -a .ext_src/imgui ext_src
	cp -a .ext_src/noc ext_src
	cp -a .ext_src/inih ext_src
	cp -a .ext_src/stb ext_src
	cp -a .ext_src/cycles ext_src
	scons cycles=0 debug=0 -j 8 --no-cache
	cp -a ./osx/goxel/goxel/Assets.xcassets/AppIcon.appiconset/64.png ./goxel.png
	rm ext_src -rf
	mv .ext_src ext_src

override_dh_installman:
	help2man -N --no-discard-stderr \
		--no-info --version-string="$(DEB_VERSION)" \
		-n "3D voxel editor" ./goxel > debian/goxel.1
	dh_installman ./debian/goxel.1

override_dh_usrlocal:
	true

override_dh_auto_install:
	dh_auto_install
	rm debian/goxel/usr/local/bin/goxel

## goxel 0.8.1

=== Makefile ===
--- 
+++ 
@@ -12,10 +12,6 @@
 
 run:
 	./goxel
-
-.PHONY: js
-js:
-	$(EMSCRIPTEN)/emscons scons debug=0 emscripten=1
 
 clean:
 	scons -c

=== SConstruct ===
# Goxel 3D voxels editor
#
# copyright (c) 2018 Guillaume Chereau <guillaume@noctua-software.com>
#
# Goxel is free software: you can redistribute it and/or modify it under the
# terms of the GNU General Public License as published by the Free Software
# Foundation, either version 3 of the License, or (at your option) any later
# version.
#
# Goxel is distributed in the hope that it will be useful, but WITHOUT ANY
# WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
#
# You should have received a copy of the GNU General Public License along with
# goxel.  If not, see <http://www.gnu.org/licenses/>.

import glob
import os
import sys

target_os = str(Platform())

debug = int(ARGUMENTS.get('debug', 1))
profile = int(ARGUMENTS.get('profile', 0))
werror = int(ARGUMENTS.get("werror", 1))
clang = int(ARGUMENTS.get("clang", 0))
argp_standalone = int(ARGUMENTS.get("argp_standalone", 0))
cycles = int(ARGUMENTS.get('cycles', 1))
sound = False

if os.environ.get('CC') == 'clang': clang = 1
if profile: debug = 0

env = Environment(ENV = os.environ)
conf = env.Configure()

if clang:
    env.Replace(CC='clang', CXX='clang++')

# Asan & Ubsan (need to come first).
# Cycles doesn't like libasan with clang, so we only use it on
# C code with clang.
if debug and target_os == 'posix':
    if not clang:
        env.Append(CCFLAGS=['-fsanitize=address', '-fsanitize=undefined'],
                   LINKFLAGS=['-fsanitize=address', '-fsanitize=undefined'],
                   LIBS=['asan', 'ubsan'])
    else:
        env.Append(CFLAGS=['-fsanitize=address', '-fsanitize=undefined'],
                   LINKFLAGS=['-fsanitize=address', '-fsanitize=undefined'])


# Global compilation flags.
# CCFLAGS   : C and C++
# CFLAGS    : only C
# CXXFLAGS  : only C++
env.Append(
    CFLAGS=['-std=gnu99', '-Wall',
            '-Wno-unknow-pragma', '-Wno-unknown-warning-option'],
    CXXFLAGS=['-std=gnu++11', '-Wall', '-Wno-narrowing']
)

if werror:
    env.Append(CCFLAGS='-Werror')


if debug:
    env.Append(CCFLAGS=['-O1'])
    if env['CC'] == 'gcc': env.Append(CCFLAGS='-Og')
else:
    env.Append(CCFLAGS=['-O3', '-DNDEBUG'])
    if env['CC'] == 'gcc': env.Append(CFLAGS='-Ofast', CXXFLAGS='-Ofast')

if profile or debug:
    env.Append(CCFLAGS='-g')

env.Append(CPPPATH=['src'])

sources = glob.glob('src/*.c') + glob.glob('src/*.cpp') + \
          glob.glob('src/formats/*.c') + \
          glob.glob('src/tools/*.c')

# Check for libpng.
if conf.CheckLibWithHeader('libpng', 'png.h', 'c'):
    env.Append(CCFLAGS='-DHAVE_LIBPNG=1')

# Linux compilation support.
if target_os == 'posix':
    env.Append(LIBS=['GL', 'm', 'z'])
    if not conf.CheckDeclaration('__GLIBC__', includes='#include <features.h>'):
        env.Append(LIBS=['argp'])
    # Note: add '--static' to link with all the libs needed by glfw3.
    env.ParseConfig('pkg-config --libs glfw3')
    env.ParseConfig('pkg-config --cflags --libs gtk+-3.0')

# Windows compilation support.
if target_os == 'msys':
    env.Append(CCFLAGS='-DNO_ARGP')
    env.Append(CXXFLAGS=['-Wno-attributes', '-Wno-unused-variable',
                         '-DFREE_WINDOWS'])
    env.Append(LIBS=['glfw3', 'opengl32', 'Imm32', 'gdi32', 'Comdlg32',
                     'z', 'tre', 'intl', 'iconv'],
               LINKFLAGS='--static')
    sources += glob.glob('ext_src/glew/glew.c')
    env.Append(CPPPATH=['ext_src/glew'])
    env.Append(CCFLAGS='-DGLEW_STATIC')

# OSX Compilation support.
if target_os == 'darwin':
    sources += glob.glob('src/*.m')
    env.Append(FRAMEWORKS=['OpenGL', 'Cocoa'])
    env.Append(LIBS=['m', 'z', 'argp', 'glfw3', 'objc'])

# Add external libs.
env.Append(CPPPATH=['ext_src/uthash'])
env.Append(CPPPATH=['ext_src/stb'])
env.Append(CPPPATH=['ext_src/noc'])

sources += glob.glob('ext_src/inih/*.c')
env.Append(CPPPATH=['ext_src/inih'])
env.Append(CFLAGS='-DINI_HANDLER_LINENO=1')

if sound:
    env.Append(LIBS='openal')
    env.Append(CCFLAGS='-DSOUND=1')

if argp_standalone:
    env.Append(LIBS='argp')


# Cycles rendering support.
if cycles:
    sources += glob.glob('ext_src/cycles/src/util/*.cpp')
    sources = [x for x in sources if not x.endswith('util_view.cpp')]
    sources += glob.glob('ext_src/cycles/src/bvh/*.cpp')
    sources += glob.glob('ext_src/cycles/src/render/*.cpp')
    sources += glob.glob('ext_src/cycles/src/graph/*.cpp')
    sources = [x for x in sources if not x.endswith('node_xml.cpp')]

    sources += glob.glob('ext_src/cycles/src/device/device.cpp')
    sources += glob.glob('ext_src/cycles/src/device/device_cpu.cpp')
    sources += glob.glob('ext_src/cycles/src/device/device_memory.cpp')
    sources += glob.glob('ext_src/cycles/src/device/device_denoising.cpp')
    sources += glob.glob('ext_src/cycles/src/device/device_split_kernel.cpp')
    sources += glob.glob('ext_src/cycles/src/device/device_task.cpp')

    sources += glob.glob('ext_src/cycles/src/kernel/kernels/cpu/*.cpp')
    sources += glob.glob('ext_src/cycles/src/subd/*.cpp')

    env.Append(CPPPATH=['ext_src/cycles/src'])
    env.Append(CPPPATH=['ext_src/cycles/third_party/atomic'])
    env.Append(CPPFLAGS=[
        '-DCYCLES_STD_UNORDERED_MAP',
        '-DCCL_NAMESPACE_BEGIN=namespace ccl {',
        '-DCCL_NAMESPACE_END=}',
        '-DWITH_CUDA_DYNLOAD',
        '-DWITHOUT_OPENIMAGEIO',
        '-DWITH_GLEW_MX',
        '-DWITH_CYCLES',
    ])
    # Try to improve compilation speed on linux.
    if not clang: env.Append(CPPFLAGS='-fno-var-tracking-assignments')
    # Seems to fix a crash on windows and i386 targets!
    env.Append(CXXFLAGS='-msse2 -fno-tree-slp-vectorize')
    if target_os == 'msys': env.Append(CXXFLAGS='-O3')
    env.Append(CPPFLAGS=['-Wno-sign-compare', '-Wno-strict-aliasing',
                         '-Wno-uninitialized'])
    if clang:
        env.Append(CPPFLAGS=['-Wno-overloaded-virtual'])

# Append external environment flags
env.Append(
    CFLAGS=os.environ.get("CFLAGS", "").split(),
    CXXFLAGS=os.environ.get("CXXFLAGS", "").split(),
    LINKFLAGS=os.environ.get("LDFLAGS", "").split()
)

env.Program(target='goxel', source=sources)

=== ext_src/cycles/src/device/CMakeLists.txt ===

set(INC
	..
	../../glew-mx
)

set(INC_SYS
	${GLEW_INCLUDE_DIR}
	../../../extern/clew/include
)

if(WITH_CUDA_DYNLOAD)
	list(APPEND INC
		../../../extern/cuew/include
	)
	add_definitions(-DWITH_CUDA_DYNLOAD)
else()
	list(APPEND INC_SYS
		${CUDA_TOOLKIT_INCLUDE}
	)
	add_definitions(-DCYCLES_CUDA_NVCC_EXECUTABLE="${CUDA_NVCC_EXECUTABLE}")
endif()

set(SRC
	device.cpp
	device_cpu.cpp
	device_cuda.cpp
	device_denoising.cpp
	device_memory.cpp
	device_multi.cpp
	device_opencl.cpp
	device_split_kernel.cpp
	device_task.cpp
)

set(SRC_OPENCL
	opencl/opencl.h
	opencl/memory_manager.h

	opencl/opencl_base.cpp
	opencl/opencl_mega.cpp
	opencl/opencl_split.cpp
	opencl/opencl_util.cpp
	opencl/memory_manager.cpp
)

if(WITH_CYCLES_NETWORK)
	list(APPEND SRC
		device_network.cpp
	)
endif()

set(SRC_HEADERS
	device.h
	device_denoising.h
	device_memory.h
	device_intern.h
	device_network.h
	device_split_kernel.h
	device_task.h
)

add_definitions(${GL_DEFINITIONS})
if(WITH_CYCLES_NETWORK)
	add_definitions(-DWITH_NETWORK)
endif()
if(WITH_CYCLES_DEVICE_OPENCL)
	add_definitions(-DWITH_OPENCL)
endif()
if(WITH_CYCLES_DEVICE_CUDA)
	add_definitions(-DWITH_CUDA)
endif()
if(WITH_CYCLES_DEVICE_MULTI)
	add_definitions(-DWITH_MULTI)
endif()

include_directories(${INC})
include_directories(SYSTEM ${INC_SYS})

cycles_add_library(cycles_device ${SRC} ${SRC_OPENCL} ${SRC_HEADERS})

=== ext_src/cycles/src/kernel/CMakeLists.txt ===
remove_extra_strict_flags()

set(INC
	..
)

set(INC_SYS

)

set(SRC_CPU_KERNELS
	kernels/cpu/kernel.cpp
	kernels/cpu/kernel_sse2.cpp
	kernels/cpu/kernel_sse3.cpp
	kernels/cpu/kernel_sse41.cpp
	kernels/cpu/kernel_avx.cpp
	kernels/cpu/kernel_avx2.cpp
	kernels/cpu/kernel_split.cpp
	kernels/cpu/kernel_split_sse2.cpp
	kernels/cpu/kernel_split_sse3.cpp
	kernels/cpu/kernel_split_sse41.cpp
	kernels/cpu/kernel_split_avx.cpp
	kernels/cpu/kernel_split_avx2.cpp
	kernels/cpu/filter.cpp
	kernels/cpu/filter_sse2.cpp
	kernels/cpu/filter_sse3.cpp
	kernels/cpu/filter_sse41.cpp
	kernels/cpu/filter_avx.cpp
	kernels/cpu/filter_avx2.cpp
)

set(SRC_CUDA_KERNELS
	kernels/cuda/kernel.cu
	kernels/cuda/kernel_split.cu
	kernels/cuda/filter.cu
)

set(SRC_OPENCL_KERNELS
	kernels/opencl/kernel.cl
	kernels/opencl/kernel_state_buffer_size.cl
	kernels/opencl/kernel_split.cl
	kernels/opencl/kernel_data_init.cl
	kernels/opencl/kernel_path_init.cl
	kernels/opencl/kernel_queue_enqueue.cl
	kernels/opencl/kernel_scene_intersect.cl
	kernels/opencl/kernel_lamp_emission.cl
	kernels/opencl/kernel_do_volume.cl
	kernels/opencl/kernel_indirect_background.cl
	kernels/opencl/kernel_shader_setup.cl
	kernels/opencl/kernel_shader_sort.cl
	kernels/opencl/kernel_shader_eval.cl
	kernels/opencl/kernel_holdout_emission_blurring_pathtermination_ao.cl
	kernels/opencl/kernel_subsurface_scatter.cl
	kernels/opencl/kernel_direct_lighting.cl
	kernels/opencl/kernel_shadow_blocked_ao.cl
	kernels/opencl/kernel_shadow_blocked_dl.cl
	kernels/opencl/kernel_enqueue_inactive.cl
	kernels/opencl/kernel_next_iteration_setup.cl
	kernels/opencl/kernel_indirect_subsurface.cl
	kernels/opencl/kernel_buffer_update.cl
	kernels/opencl/filter.cl
)

set(SRC_BVH_HEADERS
	bvh/bvh.h
	bvh/bvh_nodes.h
	bvh/bvh_shadow_all.h
	bvh/bvh_local.h
	bvh/bvh_traversal.h
	bvh/bvh_types.h
	bvh/bvh_volume.h
	bvh/bvh_volume_all.h
	bvh/qbvh_nodes.h
	bvh/qbvh_shadow_all.h
	bvh/qbvh_local.h
	bvh/qbvh_traversal.h
	bvh/qbvh_volume.h
	bvh/qbvh_volume_all.h
)

set(SRC_HEADERS
	kernel_accumulate.h
	kernel_bake.h
	kernel_camera.h
	kernel_compat_cpu.h
	kernel_compat_cuda.h
	kernel_compat_opencl.h
	kernel_differential.h
	kernel_emission.h
	kernel_film.h
	kernel_globals.h
	kernel_jitter.h
	kernel_light.h
	kernel_math.h
	kernel_montecarlo.h
	kernel_passes.h
	kernel_path.h
	kernel_path_branched.h
	kernel_path_common.h
	kernel_path_state.h
	kernel_path_surface.h
	kernel_path_subsurface.h
	kernel_path_volume.h
	kernel_projection.h
	kernel_queues.h
	kernel_random.h
	kernel_shader.h
	kernel_shadow.h
	kernel_subsurface.h
	kernel_textures.h
	kernel_types.h
	kernel_volume.h
	kernel_work_stealing.h
)

set(SRC_KERNELS_CPU_HEADERS
	kernel.h
	kernels/cpu/kernel_cpu.h
	kernels/cpu/kernel_cpu_impl.h
	kernels/cpu/kernel_cpu_image.h
	kernels/cpu/filter_cpu.h
	kernels/cpu/filter_cpu_impl.h
)

set(SRC_KERNELS_CUDA_HEADERS
	kernels/cuda/kernel_config.h
	kernels/cuda/kernel_cuda_image.h
)

set(SRC_KERNELS_OPENCL_HEADERS
	kernels/opencl/kernel_split_function.h
	kernels/opencl/kernel_opencl_image.h
)

set(SRC_CLOSURE_HEADERS
	closure/alloc.h
	closure/bsdf.h
	closure/bsdf_ashikhmin_velvet.h
	closure/bsdf_diffuse.h
	closure/bsdf_diffuse_ramp.h
	closure/bsdf_microfacet.h
	closure/bsdf_microfacet_multi.h
	closure/bsdf_microfacet_multi_impl.h
	closure/bsdf_oren_nayar.h
	closure/bsdf_phong_ramp.h
	closure/bsdf_reflection.h
	closure/bsdf_refraction.h
	closure/bsdf_toon.h
	closure/bsdf_transparent.h
	closure/bsdf_util.h
	closure/bsdf_ashikhmin_shirley.h
	closure/bsdf_hair.h
	closure/bssrdf.h
	closure/emissive.h
	closure/volume.h
	closure/bsdf_principled_diffuse.h
	closure/bsdf_principled_sheen.h
)

set(SRC_SVM_HEADERS
	svm/svm.h
	svm/svm_attribute.h
	svm/svm_bevel.h
	svm/svm_blackbody.h
	svm/svm_bump.h
	svm/svm_camera.h
	svm/svm_closure.h
	svm/svm_convert.h
	svm/svm_checker.h
	svm/svm_color_util.h
	svm/svm_brick.h
	svm/svm_displace.h
	svm/svm_fresnel.h
	svm/svm_wireframe.h
	svm/svm_wavelength.h
	svm/svm_gamma.h
	svm/svm_brightness.h
	svm/svm_geometry.h
	svm/svm_gradient.h
	svm/svm_hsv.h
	svm/svm_image.h
	svm/svm_invert.h
	svm/svm_light_path.h
	svm/svm_magic.h
	svm/svm_mapping.h
	svm/svm_math.h
	svm/svm_math_util.h
	svm/svm_mix.h
	svm/svm_musgrave.h
	svm/svm_noise.h
	svm/svm_noisetex.h
	svm/svm_normal.h
	svm/svm_ramp.h
	svm/svm_ramp_util.h
	svm/svm_sepcomb_hsv.h
	svm/svm_sepcomb_vector.h
	svm/svm_sky.h
	svm/svm_tex_coord.h
	svm/svm_texture.h
	svm/svm_types.h
	svm/svm_value.h
	svm/svm_vector_transform.h
	svm/svm_voronoi.h
	svm/svm_voxel.h
	svm/svm_wave.h
)

set(SRC_GEOM_HEADERS
	geom/geom.h
	geom/geom_attribute.h
	geom/geom_curve.h
	geom/geom_curve_intersect.h
	geom/geom_motion_curve.h
	geom/geom_motion_triangle.h
	geom/geom_motion_triangle_intersect.h
	geom/geom_motion_triangle_shader.h
	geom/geom_object.h
	geom/geom_patch.h
	geom/geom_primitive.h
	geom/geom_subd_triangle.h
	geom/geom_triangle.h
	geom/geom_triangle_intersect.h
	geom/geom_volume.h
)

set(SRC_FILTER_HEADERS
	filter/filter.h
	filter/filter_defines.h
	filter/filter_features.h
	filter/filter_features_sse.h
	filter/filter_kernel.h
	filter/filter_nlm_cpu.h
	filter/filter_nlm_gpu.h
	filter/filter_prefilter.h
	filter/filter_reconstruction.h
	filter/filter_transform.h
	filter/filter_transform_gpu.h
	filter/filter_transform_sse.h
)

set(SRC_UTIL_HEADERS
	../util/util_atomic.h
	../util/util_color.h
	../util/util_defines.h
	../util/util_half.h
	../util/util_hash.h
	../util/util_math.h
	../util/util_math_fast.h
	../util/util_math_intersect.h
	../util/util_math_float2.h
	../util/util_math_float3.h
	../util/util_math_float4.h
	../util/util_math_int2.h
	../util/util_math_int3.h
	../util/util_math_int4.h
	../util/util_math_matrix.h
	../util/util_rect.h
	../util/util_static_assert.h
	../util/util_transform.h
	../util/util_texture.h
	../util/util_types.h
	../util/util_types_float2.h
	../util/util_types_float2_impl.h
	../util/util_types_float3.h
	../util/util_types_float3_impl.h
	../util/util_types_float4.h
	../util/util_types_float4_impl.h
	../util/util_types_int2.h
	../util/util_types_int2_impl.h
	../util/util_types_int3.h
	../util/util_types_int3_impl.h
	../util/util_types_int4.h
	../util/util_types_int4_impl.h
	../util/util_types_uchar2.h
	../util/util_types_uchar2_impl.h
	../util/util_types_uchar3.h
	../util/util_types_uchar3_impl.h
	../util/util_types_uchar4.h
	../util/util_types_uchar4_impl.h
	../util/util_types_uint2.h
	../util/util_types_uint2_impl.h
	../util/util_types_uint3.h
	../util/util_types_uint3_impl.h
	../util/util_types_uint4.h
	../util/util_types_uint4_impl.h
	../util/util_types_vector3.h
	../util/util_types_vector3_impl.h
)

set(SRC_SPLIT_HEADERS
	split/kernel_branched.h
	split/kernel_buffer_update.h
	split/kernel_data_init.h
	split/kernel_direct_lighting.h
	split/kernel_do_volume.h
	split/kernel_enqueue_inactive.h
	split/kernel_holdout_emission_blurring_pathtermination_ao.h
	split/kernel_indirect_background.h
	split/kernel_indirect_subsurface.h
	split/kernel_lamp_emission.h
	split/kernel_next_iteration_setup.h
	split/kernel_path_init.h
	split/kernel_queue_enqueue.h
	split/kernel_scene_intersect.h
	split/kernel_shader_setup.h
	split/kernel_shader_sort.h
	split/kernel_shader_eval.h
	split/kernel_shadow_blocked_ao.h
	split/kernel_shadow_blocked_dl.h
	split/kernel_split_common.h
	split/kernel_split_data.h
	split/kernel_split_data_types.h
	split/kernel_subsurface_scatter.h
)

# CUDA module

if(WITH_CYCLES_CUDA_BINARIES)
	# 64 bit only
	set(CUDA_BITS 64)

	# CUDA version
	execute_process(COMMAND ${CUDA_NVCC_EXECUTABLE} "--version" OUTPUT_VARIABLE NVCC_OUT)
	string(REGEX REPLACE ".*release ([0-9]+)\\.([0-9]+).*" "\\1" CUDA_VERSION_MAJOR "${NVCC_OUT}")
	string(REGEX REPLACE ".*release ([0-9]+)\\.([0-9]+).*" "\\2" CUDA_VERSION_MINOR "${NVCC_OUT}")
	set(CUDA_VERSION "${CUDA_VERSION_MAJOR}${CUDA_VERSION_MINOR}")

	# warn for other versions
	if(CUDA_VERSION MATCHES "80" OR CUDA_VERSION MATCHES "90")
	else()
		message(WARNING
			"CUDA version ${CUDA_VERSION_MAJOR}.${CUDA_VERSION_MINOR} detected, "
			"build may succeed but only CUDA 8.0 is officially supported")
	endif()

	# build for each arch
	set(cuda_sources kernels/cuda/kernel.cu kernels/cuda/kernel_split.cu
		${SRC_HEADERS}
		${SRC_KERNELS_CUDA_HEADERS}
		${SRC_BVH_HEADERS}
		${SRC_SVM_HEADERS}
		${SRC_GEOM_HEADERS}
		${SRC_CLOSURE_HEADERS}
		${SRC_UTIL_HEADERS}
	)
	set(cuda_filter_sources kernels/cuda/filter.cu
		${SRC_HEADERS}
		${SRC_KERNELS_CUDA_HEADERS}
		${SRC_FILTER_HEADERS}
		${SRC_UTIL_HEADERS}
	)
	set(cuda_cubins)

	macro(CYCLES_CUDA_KERNEL_ADD arch name flags sources experimental)
		set(cuda_cubin ${name}_${arch}.cubin)
		set(cuda_kernel_src "/kernels/cuda/${name}.cu")

		set(cuda_flags
			-D CCL_NAMESPACE_BEGIN=
			-D CCL_NAMESPACE_END=
			-D NVCC
			-m ${CUDA_BITS}
			-I ${CMAKE_CURRENT_SOURCE_DIR}/..
			-I ${CMAKE_CURRENT_SOURCE_DIR}/kernels/cuda
			--use_fast_math
			-o ${CMAKE_CURRENT_BINARY_DIR}/${cuda_cubin})

		if(${experimental})
			set(cuda_flags ${cuda_flags} -D __KERNEL_EXPERIMENTAL__)
			set(name ${name}_experimental)
		endif()

		if(WITH_CYCLES_DEBUG)
			set(cuda_flags ${cuda_flags} -D __KERNEL_DEBUG__)
		endif()

		if(WITH_CYCLES_CUBIN_COMPILER)
			string(SUBSTRING ${arch} 3 -1 CUDA_ARCH)

			# Needed to find libnvrtc-builtins.so. Can't do it from inside
			# cycles_cubin_cc since the env variable is read before main()
			if(APPLE)
				set(CUBIN_CC_ENV ${CMAKE_COMMAND}
					-E env DYLD_LIBRARY_PATH="${CUDA_TOOLKIT_ROOT_DIR}/lib")
			elseif(UNIX)
				set(CUBIN_CC_ENV ${CMAKE_COMMAND}
					-E env LD_LIBRARY_PATH="${CUDA_TOOLKIT_ROOT_DIR}/lib64")
			endif()

			add_custom_command(
				OUTPUT ${cuda_cubin}
				COMMAND ${CUBIN_CC_ENV}
						"$<TARGET_FILE:cycles_cubin_cc>"
						-target ${CUDA_ARCH}
						-i ${CMAKE_CURRENT_SOURCE_DIR}${cuda_kernel_src}
						${cuda_flags}
						-v
						-cuda-toolkit-dir "${CUDA_TOOLKIT_ROOT_DIR}"
				DEPENDS ${sources} cycles_cubin_cc)
		else()
			add_custom_command(
				OUTPUT ${cuda_cubin}
				COMMAND ${CUDA_NVCC_EXECUTABLE}
						-arch=${arch}
						${CUDA_NVCC_FLAGS}
						--cubin
						${CMAKE_CURRENT_SOURCE_DIR}${cuda_kernel_src}
						--ptxas-options="-v"
						${cuda_flags}
				DEPENDS ${sources})
		endif()
		delayed_install("${CMAKE_CURRENT_BINARY_DIR}" "${cuda_cubin}" ${CYCLES_INSTALL_PATH}/lib)
		list(APPEND cuda_cubins ${cuda_cubin})

		unset(cuda_debug_flags)
	endmacro()

	foreach(arch ${CYCLES_CUDA_BINARIES_ARCH})
		if(${arch} MATCHES "sm_2.")
			message(STATUS "CUDA binaries for ${arch} are no longer supported, skipped.")
		else()
			# Compile regular kernel
			CYCLES_CUDA_KERNEL_ADD(${arch} filter "" "${cuda_filter_sources}" FALSE)
			CYCLES_CUDA_KERNEL_ADD(${arch} kernel "" "${cuda_sources}" FALSE)
		endif()

		if(WITH_CYCLES_CUDA_SPLIT_KERNEL_BINARIES)
			# Compile split kernel
			CYCLES_CUDA_KERNEL_ADD(${arch} kernel_split "-D __SPLIT__" ${cuda_sources} FALSE)
		endif()
	endforeach()

	add_custom_target(cycles_kernel_cuda ALL DEPENDS ${cuda_cubins})
	cycles_set_solution_folder(cycles_kernel_cuda)
endif()

# OSL module

if(WITH_CYCLES_OSL)
	add_subdirectory(osl)
	add_subdirectory(shaders)
endif()

# CPU module

include_directories(${INC})
include_directories(SYSTEM ${INC_SYS})

set_source_files_properties(kernels/cpu/kernel.cpp PROPERTIES COMPILE_FLAGS "${CYCLES_KERNEL_FLAGS}")
set_source_files_properties(kernels/cpu/kernel_split.cpp PROPERTIES COMPILE_FLAGS "${CYCLES_KERNEL_FLAGS}")
set_source_files_properties(kernels/cpu/filter.cpp PROPERTIES COMPILE_FLAGS "${CYCLES_KERNEL_FLAGS}")

if(CXX_HAS_SSE)
	set_source_files_properties(kernels/cpu/kernel_sse2.cpp PROPERTIES COMPILE_FLAGS "${CYCLES_SSE2_KERNEL_FLAGS}")
	set_source_files_properties(kernels/cpu/kernel_sse3.cpp PROPERTIES COMPILE_FLAGS "${CYCLES_SSE3_KERNEL_FLAGS}")
	set_source_files_properties(kernels/cpu/kernel_sse41.cpp PROPERTIES COMPILE_FLAGS "${CYCLES_SSE41_KERNEL_FLAGS}")
	set_source_files_properties(kernels/cpu/kernel_split_sse2.cpp PROPERTIES COMPILE_FLAGS "${CYCLES_SSE2_KERNEL_FLAGS}")

=== ext_src/cycles/src/kernel/osl/CMakeLists.txt ===

set(INC
	../..
)

set(INC_SYS

)

set(SRC
	background.cpp
	bsdf_diffuse_ramp.cpp
	bsdf_phong_ramp.cpp
	emissive.cpp
	osl_bssrdf.cpp
	osl_closures.cpp
	osl_services.cpp
	osl_shader.cpp
)

set(HEADER_SRC
	osl_closures.h
	osl_globals.h
	osl_services.h
	osl_shader.h
)

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${RTTI_DISABLE_FLAGS}")

include_directories(${INC})
include_directories(SYSTEM ${INC_SYS})

cycles_add_library(cycles_kernel_osl ${SRC} ${HEADER_SRC})

=== ext_src/cycles/src/kernel/shaders/CMakeLists.txt ===

# OSL node shaders

set(SRC_OSL
	node_add_closure.osl
	node_ambient_occlusion.osl
	node_anisotropic_bsdf.osl
	node_attribute.osl
	node_background.osl
	node_bevel.osl
	node_brick_texture.osl
	node_brightness.osl
	node_bump.osl
	node_camera.osl
	node_checker_texture.osl
	node_combine_rgb.osl
	node_combine_hsv.osl
	node_combine_xyz.osl
	node_convert_from_color.osl
	node_convert_from_float.osl
	node_convert_from_int.osl
	node_convert_from_normal.osl
	node_convert_from_point.osl
	node_convert_from_vector.osl
	node_diffuse_bsdf.osl
	node_displacement.osl
	node_vector_displacement.osl
	node_emission.osl
	node_environment_texture.osl
	node_fresnel.osl
	node_gamma.osl
	node_geometry.osl
	node_glass_bsdf.osl
	node_glossy_bsdf.osl
	node_gradient_texture.osl
	node_hair_info.osl
	node_scatter_volume.osl
	node_absorption_volume.osl
	node_principled_volume.osl
	node_holdout.osl
	node_hsv.osl
	node_image_texture.osl
	node_invert.osl
	node_layer_weight.osl
	node_light_falloff.osl
	node_light_path.osl
	node_magic_texture.osl
	node_mapping.osl
	node_math.osl
	node_mix.osl
	node_mix_closure.osl
	node_musgrave_texture.osl
	node_noise_texture.osl
	node_normal.osl
	node_normal_map.osl
	node_object_info.osl
	node_output_displacement.osl
	node_output_surface.osl
	node_output_volume.osl
	node_particle_info.osl
	node_refraction_bsdf.osl
	node_rgb_curves.osl
	node_rgb_ramp.osl
	node_separate_rgb.osl
	node_separate_hsv.osl
	node_separate_xyz.osl
	node_set_normal.osl
	node_sky_texture.osl
	node_subsurface_scattering.osl
	node_tangent.osl
	node_texture_coordinate.osl
	node_toon_bsdf.osl
	node_translucent_bsdf.osl
	node_transparent_bsdf.osl
	node_value.osl
	node_vector_curves.osl
	node_vector_math.osl
	node_vector_transform.osl
	node_velvet_bsdf.osl
	node_voronoi_texture.osl
	node_voxel_texture.osl
	node_wavelength.osl
	node_blackbody.osl
	node_wave_texture.osl
	node_wireframe.osl
	node_hair_bsdf.osl
	node_uv_map.osl
	node_principled_bsdf.osl
	node_rgb_to_bw.osl
)

set(SRC_OSL_HEADERS
	node_color.h
	node_fresnel.h
	node_ramp_util.h
	node_texture.h
	stdosl.h
	oslutil.h
)

set(SRC_OSO

)

# TODO, add a module to compile OSL
foreach(_file ${SRC_OSL})
	set(_OSL_FILE ${CMAKE_CURRENT_SOURCE_DIR}/${_file})
	set_source_files_properties(${_file} PROPERTIES HEADER_FILE_ONLY TRUE)
	string(REPLACE ".osl" ".oso" _OSO_FILE ${_OSL_FILE})
	string(REPLACE ${CMAKE_SOURCE_DIR} ${CMAKE_BINARY_DIR} _OSO_FILE ${_OSO_FILE})
	add_custom_command(
		OUTPUT ${_OSO_FILE} 
		COMMAND ${OSL_COMPILER} -q -O2  -I"${CMAKE_CURRENT_SOURCE_DIR}" -o ${_OSO_FILE} ${_OSL_FILE}
		DEPENDS ${_OSL_FILE} ${SRC_OSL_HEADERS} ${OSL_COMPILER})
	list(APPEND SRC_OSO
		${_OSO_FILE}
	)

	unset(_OSL_FILE)
	unset(_OSO_FILE)
endforeach()

add_custom_target(cycles_osl_shaders ALL DEPENDS ${SRC_OSO} ${SRC_OSL_HEADERS} ${OSL_COMPILER} SOURCES ${SRC_OSL})
cycles_set_solution_folder(cycles_osl_shaders)

# CMAKE_CURRENT_SOURCE_DIR is already included in OSO paths
delayed_install("" "${SRC_OSO}" ${CYCLES_INSTALL_PATH}/shader)
delayed_install("${CMAKE_CURRENT_SOURCE_DIR}" "${SRC_OSL_HEADERS}" ${CYCLES_INSTALL_PATH}/shader)

=== debian/changelog ===
goxel (0.8.1-1build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 22 Mar 2020 16:42:52 +0100

goxel (0.8.1-1) unstable; urgency=medium

  * New upstream release

 -- Federico Ceratto <federico@debian.org>  Sat, 29 Sep 2018 16:30:40 +0100

goxel (0.8.0-2) unstable; urgency=medium

  * Fix install paths (Closes: #907448)

 -- Federico Ceratto <federico@debian.org>  Mon, 17 Sep 2018 19:52:51 +0100

=== debian/control ===
--- 
+++ 
@@ -3,13 +3,14 @@
 Priority: optional
 Maintainer: Federico Ceratto <federico@debian.org>
 Build-Depends: debhelper (>= 11~),
+ clang,
  help2man,
  libglfw3-dev,
  libgtk-3-dev,
  libinih-dev,
  scons,
  uthash-dev
-Standards-Version: 4.2.0
+Standards-Version: 4.2.1
 Homepage: https://github.com/guillaumechereau/goxel
 Vcs-Git: https://salsa.debian.org/debian/goxel.git
 Vcs-Browser: https://salsa.debian.org/debian/goxel

=== debian/watch ===
version=3

opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/goxel-$1\.tar\.gz/ \
  https://github.com/guillaumechereau/goxel/tags .*/v?(\d\S*)\.tar\.gz
